////////////////////////////// TP1 Gestion de stocks  //////////////////////////

////////////////////////////////////////////////////////////////////////
// créé le 15/03/2012      mis à jour le 15/03/2012
//
// Optimisation d'un stock de machines
//
// Descriptif des paramètres
//   n   nombre de machines
//   p   probabilité de panne d'une machine
//   K   ratio d'une défaillance au coût d'une machine en stock
//   N   nombre de simulations
//
// Variables internes
//   k   nombre de machines en stock
//   C array(1,n+1) coût moyen du process    
//
///////////////////////////////////////////////////////////////////////

////////////////////////////
// Preparatifs pour scilab 
///////////////////////////

// Fermer les fenêtres graphiques
xdel(winsid())

// Supprimer les variables précédentes
clear a

//////////////////////////////
// Lancement de l'experience 
/////////////////////////////

// Afficher le titre sur la console
disp("Optimisation de la gestion de stock pour maintenance")  
//////////////////////////////////
 //   Fixation des paramètres    //
//////////////////////////////////
n=10;
p=0.2;
K=4;
N=100;

  //////////////////////////////////
 //   Calcul de probabilités     //
//////////////////////////////////
Cm=zeros(1,n+1);
un=ones(1,n+1);
[P,Q]=cdfbin("PQ",0:n,n*un,p*un,(1-p)*un);
k=0; Cm(k+1)=K*n*p;
for k=1:n
    Cm(k+1)=Cm(k)+1-K*Q(k);
end

  //////////////////////
 //   Simulation     //
//////////////////////

Csim=zeros(N,n+1);

X=rand(N,n)<p;
NXsim=sum(X,2);
for k=0:n
    Csim(:,k+1)=k+K*max((NXsim(:)-k),0)
end
Csim_m=mean(Csim,1);
Csim_std=st_deviation(Csim,1);

for k=0:n
    disp("k="+string(k)+", Coût moyen:"+string(Cm(k+1))+", Coût empirique:"+string(Csim_m(k+1)));
end